//
//  AppController.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 2/22/09.
//

#import "AppController.h"
#import "PlayerInfoCell.h"

@implementation AppController

@synthesize buttonState;

- (id)init {
	if( self = [super init] ) {
		buttonState = NO;
	}
	return self;
}

- (void) awakeFromNib {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[spinner startRendering];
	[spinner pauseRendering];
	
	NSTableColumn *column = [[playerTable tableColumns] objectAtIndex:0];
	PlayerInfoCell *cell = [[PlayerInfoCell alloc] init];
	[column setDataCell:cell];
	
	[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(setSpinButtonEnabled:) 
												 name:@"EnableSpinButton" 
											   object:nil];
	
	[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(setSpinButtonDisabled:) 
												 name:@"DisableSpinButton" 
											   object:nil];
}


- (void)setSpinButtonDisabled:(NSNotification*)aNotification {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[self setButtonState:NO];
}

- (void)setSpinButtonEnabled:(NSNotification*)aNotification {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[self setButtonState:YES];
}

@end
