//
//  BankViewController.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 5/10/09.
//

#import "BankViewController.h"
#import "Game.h"
#import "Player.h"
#import "Loan.h"
#import "PlayerTableDataSource.h"

@implementation BankViewController

- (id)init {
	if( self = [super init] ) {
	}
	return self;
}

- (NSInteger)numberOfRowsInTableView:(NSTableView*)aTable {
	Player *curPlayer = [playerTable currentPlayer];
	if( curPlayer ) {
		playerLoans = [curPlayer loans];
		return [playerLoans count];
	} else {
		return 0;
	}
}

- (id)tableView:(NSTableView*)aTable objectValueForTableColumn:(NSTableColumn*)aColumn row:(NSInteger)row {
	Player *curPlayer = [playerTable currentPlayer];
	playerLoans = [curPlayer loans];
	if( row < [playerLoans count]) {
		Loan *loan = [playerLoans objectAtIndex:row];
		NSInteger loanAmount = [loan amount];
		NSString *amount = [NSString stringWithFormat:@"%d", loanAmount];
		return amount;
	} else {
		return @"";
	}
}

- (IBAction)takeLoan:(id)sender {
	NSInteger amount = [newLoanAmount intValue];
	Loan *newLoan = [[Loan alloc] initWithAmount:amount];
	Player *curPlayer = [playerTable currentPlayer];
	[curPlayer  addLoan:newLoan];
	[tableView reloadData];
}


- (IBAction)payLoan:(id)sender {
	NSInteger row = [tableView selectedRow];
	if( row != -1 ) {
		Player *curPlayer = [playerTable currentPlayer];
		playerLoans = [curPlayer loans];
		Loan *loanToPay = [playerLoans objectAtIndex:row];
		[curPlayer payLoan:loanToPay];
	}

	[tableView reloadData];
}

@end

