//
//  Board.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 4/11/09.
//

#import "Board.h"
#import "CareerSquare.h"
#import "PayDay.h"
#import "StopSquare.h"
#import "FinanceSquare.h"
#import "BlueSquare.h"
#import "NightSchoolSquare.h"
#import "SwapSalarySquare.h"
#import "LifeSquare.h"
#import "LoseTurnSquare.h"
#import "TaxSquare.h"
#import "BuyHouseSquare.h"
#import "BabySquare.h"
#import "StockSquare.h"
#import "SpinAgainSquare.h"
#import "RetirementSquare.h"
#import "CarInsuranceSquare.h"
#import "HouseInsuranceSquare.h"
#import "ChildFinanceSquare.h"
#import "StartCollegeSquare.h"
#import "TeacherSquare.h"
#import "SalespersonSquare.h"
#import "DoctorSquare.h"
#import "EntertainerSquare.h"
#import "AccountantSquare.h"
#import "AthleteSquare.h"
#import "ArtistSquare.h"
#import "TravelAgentSquare.h"
#import "PoliceSquare.h"
#import "CountrysideAcresSquare.h"
#import "MillionaireEstatesSquare.h"

@interface Board (PrivateMethods) 

- (void)initSquares;

@end

@implementation Board (PrivateMethods)

- (void)initSquares {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	// start career to 2nd payday
	CareerSquare *startCareer = 
		[[CareerSquare alloc] initWithPosition:NSMakePoint(1000, 540)
									andMessage:@"Start Career"];
	
	PayDay *payDaySquare = [[PayDay alloc] initWithPosition:NSMakePoint(1025, 640)];
	
	[startCareer setNextSquare:payDaySquare];
	startCareerSquare = startCareer;
	
	FinanceSquare *rentApartment = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1025, 700) 
									 andMessage:@"Rent Apartment. Pay $5,000"
									  andAmount:(-5000)];
	[payDaySquare setNextSquare:rentApartment];
	
	FinanceSquare *rafflePrize = 
	[[FinanceSquare alloc] initWithPosition:NSMakePoint(1050, 770) 
								 andMessage:@"Raffle Prize! Collect $10,000"
								  andAmount:10000];
	[rentApartment setNextSquare:rafflePrize];
	
	PayDay *secondPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(1110, 790)];
	[rafflePrize setNextSquare:secondPayDay];
	
	// start college to first payday (var: secondPayDay)
	StartCollegeSquare *startCollege = 
		[[StartCollegeSquare alloc] initWithPosition:NSMakePoint(1000, 470) 
										  andMessage:@"Start College - Borrow $40,000"];
	startCollegeSquare = startCollege;
	
	FinanceSquare *scholarship = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1030, 380) 
									 andMessage:@"Scholarship! Collect $20,000" 
									  andAmount:20000];
	[startCollege setNextSquare:scholarship];
	
	FinanceSquare *books = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1040, 320) 
									 andMessage:@"Buy books and supplies. Pay $5,000" 
									  andAmount:(-5000)];
	[scholarship setNextSquare:books];
	
	LifeSquare *makeFriends = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1090, 325) 
								  andMessage:@"Make New Friends"];
	[books setNextSquare:makeFriends];
	
	FinanceSquare *partTimeJob = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1115, 375) 
									 andMessage:@"Get Part Time Job. Collect $5,000" 
									  andAmount:5000];
	[makeFriends setNextSquare:partTimeJob];
	
	LoseTurnSquare *examCram = 
		[[LoseTurnSquare alloc] initWithPosition:NSMakePoint(1115,425) 
									  andMessage:@"Cram for Exams. Lose Next Turn."];
	[partTimeJob setNextSquare:examCram];
	
	LifeSquare *studyInEurope = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1115,475) 
								  andMessage:@"Study In Europe"];
	[examCram setNextSquare:studyInEurope];
	
	FinanceSquare *springBreak = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1115, 525) 
									 andMessage:@"Spring Break in Florida. Pay $5,000" 
									  andAmount:(-5000)];
	[studyInEurope setNextSquare:springBreak];
	
	LifeSquare *deansList = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1115, 575) 
								  andMessage:@"Dean's List!"];
	[springBreak setNextSquare:deansList];
	
	LoseTurnSquare *writePaper = 
		[[LoseTurnSquare alloc] initWithPosition:NSMakePoint(1115, 625) 
									  andMessage:@"Write term paper. Lose Next Turn"];
	[deansList setNextSquare:writePaper];
	
	LifeSquare *graduation = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1115, 675) 
								  andMessage:@"Graduation Day! (LIFE)"];
	[writePaper setNextSquare:graduation];
	
	CareerSquare *jobSearch = 
		[[CareerSquare alloc] initWithPosition:NSMakePoint(0, 0) 
									andMessage:@"Job Search"];
	StopSquare *stopAtJobSearch = 
		[[StopSquare alloc] initWithPosition:NSMakePoint(1115, 725) 
								  andMessage:@" STOP" 
								   andSquare:jobSearch];
	
	[graduation setNextSquare:stopAtJobSearch];
	
	[stopAtJobSearch setNextSquare:secondPayDay];
	
	// TODO: Find Missing Squares
	
	FinanceSquare *skiAccident = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(950, 890) 
									 andMessage:@"Ski Accident. Pay $5,000" 
									  andAmount:(-5000)];
	DoctorSquare *doc1 = [[DoctorSquare alloc] initWithPosition:NSMakePoint(950,890)
													  andSquare:skiAccident];
	[secondPayDay setNextSquare:doc1];
	
	FinanceSquare *winMarathon = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(910, 900) 
									 andMessage:@"Win Marathon! Collect $10,000" 
									  andAmount:10000];
	[doc1 setNextSquare:winMarathon];
	
	LifeSquare *noToDrugs = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(865, 920) 
								  andMessage:@"Say NO to Drugs!"];
	[winMarathon setNextSquare:noToDrugs];
	
	LifeSquare *dnd = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(840, 885) 
								  andMessage:@"Don't Drink and Drive!"];
	[noToDrugs setNextSquare:dnd];
	
	PayDay *thirdPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(870, 850)];
	[dnd setNextSquare:thirdPayDay];
	
	LoseTurnSquare *flatTire = 
		[[LoseTurnSquare alloc] initWithPosition:NSMakePoint(920, 820) 
									  andMessage:@"Flat Tire. Lose Next Turn"];
	[thirdPayDay setNextSquare:flatTire];
	
	LifeSquare *getMarried = [[LifeSquare alloc] initWithPosition:NSMakePoint(0, 0) 
													   andMessage:@"Get Married!"];
	StopSquare *stopAtGetMarried = 
		[[StopSquare alloc] initWithPosition:NSMakePoint(970, 760) 
								  andMessage:@" STOP" 
								   andSquare:getMarried];
	[flatTire setNextSquare:stopAtGetMarried];
	
	FinanceSquare *reception = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(920,690) 
									 andMessage:@"Wedding & Reception. Pay $10,000" 
									  andAmount:(-10000)];
	[stopAtGetMarried setNextSquare:reception];
	
	LifeSquare *honeymoon = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(850, 715) 
								  andMessage:@"Happy Honeymoon!"];
	[reception setNextSquare:honeymoon];
	
	FinanceSquare *furniture = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(800, 750) 
									 andMessage:@"Buy Furniture. Pay $10,000" 
									  andAmount:(-10000)];
	SalespersonSquare *sales1 = [[SalespersonSquare alloc] initWithPosition:NSMakePoint(800,750)
																  andSquare:furniture];
	[honeymoon setNextSquare:sales1];
	
	CarInsuranceSquare *accident = 
		[[CarInsuranceSquare alloc] initWithPosition:NSMakePoint(755, 785) 
										  andMessage:@"Car Accident.  Pay $10,000 if uninsured" 
										   andAmount:(-10000)];
	[sales1 setNextSquare:accident];
	
	FinanceSquare *move = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(740,835) 
									 andMessage:@"Move Across Country. Pay $10,000" 
									  andAmount:(-10000)];
	TravelAgentSquare *travel1 = [[TravelAgentSquare alloc] initWithPosition:NSMakePoint(748,835)
																   andSquare:move];
	[accident setNextSquare:travel1];
	
	NightSchoolSquare *nightSchool = 
		[[NightSchoolSquare alloc] initWithPosition:NSMakePoint(725, 895) 
										 andMessage:@"Go To Night School.  Pay $20,000" 
										  andAmount:(-20000)];
	TeacherSquare *teach1 = [[TeacherSquare alloc] initWithPosition:NSMakePoint(725,895)
														  andSquare:nightSchool];
	[travel1 setNextSquare:teach1];
	
	PayDay *fourthPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(675, 915)];
	[teach1 setNextSquare:fourthPayDay];
	
	TaxSquare *taxesDue = [[TaxSquare alloc] initWithPosition:NSMakePoint(625, 885)];
	AccountantSquare *account1 = [[AccountantSquare alloc] initWithPosition:NSMakePoint(625, 885)
																  andSquare:taxesDue];
	[fourthPayDay setNextSquare:account1];
	
	FinanceSquare *winLottery = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(620, 830) 
									 andMessage:@"Win Lottery! Collect $50,000" 
									  andAmount:50000];
	[account1 setNextSquare:winLottery];
	
	LifeSquare *inlaws = [[LifeSquare alloc] initWithPosition:NSMakePoint(620, 770) 
												   andMessage:@"Visit In-Laws"];
	[winLottery setNextSquare:inlaws];
	
	BuyHouseSquare *buyHouse = 
		[[BuyHouseSquare alloc] initWithPosition:NSMakePoint(0,0)];
	StopSquare *stopAtBuyHouse = 
		[[StopSquare alloc] initWithPosition:NSMakePoint(620, 710) 
								  andMessage:@" STOP" 
								   andSquare:buyHouse];
	[inlaws setNextSquare:stopAtBuyHouse];
	
	PayDay *fifthPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(620, 640)];
	[stopAtBuyHouse setNextSquare:fifthPayDay];
	
	CareerSquare *fired = 
		[[CareerSquare alloc] initWithPosition:NSMakePoint(620, 580) 
									andMessage:@"You're Fired! Start New Career"];
	[fifthPayDay setNextSquare:fired];
	
	BabySquare *babyBoy1 = [[BabySquare alloc] initWithPosition:NSMakePoint(620, 530) 
														 andSex:BOY];
	[fired setNextSquare:babyBoy1];
	
	FinanceSquare *babyRoom = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(620, 470) 
									 andMessage:@"Furnish Baby Room.  Pay $10,000" 
									  andAmount:(-10000)];
	SalespersonSquare *sales2 = [[SalespersonSquare alloc] initWithPosition:NSMakePoint(620, 470)
																  andSquare:babyRoom];
	[babyBoy1 setNextSquare:sales2];
	
	BabySquare *babyGirl1 = [[BabySquare alloc] initWithPosition:NSMakePoint(620, 410) 
														  andSex:GIRL];
	[sales2 setNextSquare:babyGirl1];
	
	FinanceSquare *talent = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(600,355) 
									 andMessage:@"Win Talent Contest. Collect $10,000" 
									  andAmount:10000];
	[babyGirl1 setNextSquare:talent];
	
	PayDay *sixthPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(590,300)];
	[talent setNextSquare:sixthPayDay];
	
	BabySquare *twins = [[BabySquare alloc] initWithPosition:NSMakePoint(590, 240) 
													  andSex:TWINS];
	[sixthPayDay setNextSquare:twins];
	
	FinanceSquare *worldSeries = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(590,195) 
									 andMessage:@"Box Seats at World Series. Pay $20,000" 
									  andAmount:(-20000)];
	AthleteSquare *athlete1 = [[AthleteSquare alloc] initWithPosition:NSMakePoint(590,195)
															andSquare:worldSeries];
	[twins setNextSquare:athlete1];
	
	BabySquare *babyGirl2 = [[BabySquare alloc] initWithPosition:NSMakePoint(570, 135) 
														  andSex:GIRL];
	[athlete1 setNextSquare:babyGirl2];
	
	FinanceSquare *premier = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(520,100) 
									 andMessage:@"Attend Hollywood Movie Premier. Pay $5,000" 
									  andAmount:(-5000)];
	EntertainerSquare *entertain1 = [[EntertainerSquare alloc] initWithPosition:NSMakePoint(520,100)
																	  andSquare:premier];
	[babyGirl2 setNextSquare:entertain1];
	
	FinanceSquare *flood = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(460,100) 
									 andMessage:@"House Flooded! Pay $40,000 if not Insured" 
									  andAmount:(-40000)];
	[entertain1 setNextSquare:flood];
	
	// left path
	FinanceSquare *bigscreen = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(380,90) 
									 andMessage:@"Buy Big Screen TV. Pay $5,000" 
									  andAmount:(-5000)];
	SalespersonSquare *sales3 = [[SalespersonSquare alloc] initWithPosition:NSMakePoint(380,90)
																  andSquare:bigscreen];
	[flood setNextSquare:sales3];
	
	// TODO: Find Missing Squares
	
	PayDay *leftPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(100, 160)];
	[sales3 setNextSquare:leftPayDay];
	
	CarInsuranceSquare *stolenCar = 
		[[CarInsuranceSquare alloc] initWithPosition:NSMakePoint(65, 215) 
										  andMessage:@"Car Stolen! Pay $15,000 if not Insured!" 
										   andAmount:(-15000)];
	[leftPayDay setNextSquare:stolenCar];
	// end left path
	
	// right path
	FinanceSquare *checkups = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(410, 150) 
									 andMessage:@"Family Checkups. Pay $5,000" 
									  andAmount:(-5000)];
	DoctorSquare *doc2 = [[DoctorSquare alloc] initWithPosition:NSMakePoint(410,150)
													  andSquare:checkups];
	[flood setNextSquare:doc2];
	
	SwapSalarySquare *swap1 = 
		[[SwapSalarySquare alloc] initWithPosition:NSMakePoint(390, 200)];
	[doc2 setNextSquare:swap1];
	
	BabySquare *babyBoy2 = [[BabySquare alloc] initWithPosition:NSMakePoint(370, 250) 
														 andSex:BOY];
	[swap1 setNextSquare:babyBoy2];
	
	PayDay *rightPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(305, 255)];
	[babyBoy2 setNextSquare:rightPayDay];
	
	BabySquare *babyGirlRight = [[BabySquare alloc] initWithPosition:NSMakePoint(240, 255)
															  andSex:GIRL];
	[rightPayDay setNextSquare:babyGirlRight];
	
	HouseInsuranceSquare *tree = 
		[[HouseInsuranceSquare alloc] initWithPosition:NSMakePoint(190, 255) 
											andMessage:@"Tree Falls on House. Pay $15,000 if not insured" 
											 andAmount:(-15000)];
	[babyGirlRight setNextSquare:tree];
	
	LifeSquare *wallet = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(120, 265) 
								  andMessage:@"Return Lost Wallet"];
	[tree setNextSquare:wallet];
	// end right path
	
	SwapSalarySquare *swap2 = 
		[[SwapSalarySquare alloc] initWithPosition:NSMakePoint(70, 280)];
	[stolenCar setNextSquare:swap2];
	[wallet setNextSquare:swap2];
	
	LifeSquare *mayor = [[LifeSquare alloc] initWithPosition:NSMakePoint(95, 345) 
												  andMessage:@"Run for Mayor!"];
	[swap2 setNextSquare:mayor];
	
	LifeSquare *vote = [[LifeSquare alloc] initWithPosition:NSMakePoint(155, 375) 
												 andMessage:@"Vote!"];
	[mayor setNextSquare:vote];
	
	BabySquare *babyBoy3 = [[BabySquare alloc] initWithPosition:NSMakePoint(220, 385) 
														 andSex:BOY];
	[vote setNextSquare:babyBoy3];
	
	PayDay *seventhPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(260,430)];
	[babyBoy3 setNextSquare:seventhPayDay];
	
	FinanceSquare *vacation = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(260, 490) 
									 andMessage:@"Tropical Vacation. Pay $25,000" 
									  andAmount:(-25000)];
	TravelAgentSquare *travel2 = [[TravelAgentSquare alloc] initWithPosition:NSMakePoint(260,490)
																   andSquare:vacation];
	[seventhPayDay setNextSquare:travel2];
	
	NightSchoolSquare *nightSchool2 = 
		[[NightSchoolSquare alloc] initWithPosition:NSMakePoint(260,550) 
										 andMessage:@"Go To Night School. Pay $20,000" 
										  andAmount:(-20000)];
	TeacherSquare *teach2 = [[TeacherSquare alloc] initWithPosition:NSMakePoint(260,550)
														  andSquare:nightSchool2];
	[travel2 setNextSquare:teach2];
	
	LifeSquare *cpr = [[LifeSquare alloc] initWithPosition:NSMakePoint(250, 610)
												andMessage:@"Learn CPR"];
	[teach2 setNextSquare:cpr];
	
	FinanceSquare *artAuction = [[FinanceSquare alloc] initWithPosition:NSMakePoint(220, 660)
															 andMessage:@"Art Auction. Pay $20,000" 
															  andAmount:(-20000)];
	ArtistSquare *artist1 = [[ArtistSquare alloc] initWithPosition:NSMakePoint(220, 660)
														 andSquare:artAuction];
	[cpr setNextSquare:artist1];
	
	PayDay *eightPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(170, 710)];
	[artist1 setNextSquare:eightPayDay];
	
	// TODO:  Find missing squares!
	
	TaxSquare *taxesDue2 = [[TaxSquare alloc] initWithPosition:NSMakePoint(300,910)];
	AccountantSquare *account2 = [[AccountantSquare alloc] initWithPosition:NSMakePoint(300,910)
																  andSquare:taxesDue2];
	[eightPayDay setNextSquare:account2];
	
	FinanceSquare *tennis = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(360, 910) 
									 andMessage:@"Lessons at Ace Tennis Camp. Pay $25,000" 
									  andAmount:(-25000)];
	AthleteSquare *athlete2 = [[AthleteSquare alloc] initWithPosition:NSMakePoint(360,910)
															andSquare:tennis];
	[account2 setNextSquare:athlete2];
	
	FinanceSquare *safari = [[FinanceSquare alloc] initWithPosition:NSMakePoint(420, 910) 
														 andMessage:@"African Safari. Pay $25,000" 
														  andAmount:(-25000)];
	TravelAgentSquare *travel3 = [[TravelAgentSquare alloc] initWithPosition:NSMakePoint(420, 910)
																   andSquare:safari];
	[athlete2 setNextSquare:travel3];
	
	PayDay *ninthPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(480, 910)];
	[travel3 setNextSquare:ninthPayDay];
	
	StockSquare *stockCrash = 
		[[StockSquare alloc] initWithPosition:NSMakePoint(530, 900) 
							andNumberOfStocks:(-1)];
	[ninthPayDay setNextSquare:stockCrash];
	
	LifeSquare *valentine = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(550, 860) 
								  andMessage:@"Be My Valentine!"];
	[stockCrash setNextSquare:valentine];
	
	ChildFinanceSquare *daycare = 
		[[ChildFinanceSquare alloc] initWithPosition:NSMakePoint(555, 810) 
									 andMessage:@"DayCare.  Pay $5,000 per child."
									  andAmount:(-5000)];
	TeacherSquare *teach3 = [[TeacherSquare alloc] initWithPosition:NSMakePoint(555, 810)
														  andSquare:daycare];
	[valentine setNextSquare:teach3];
	
	FinanceSquare *bestSeller = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(555, 750) 
									 andMessage:@"Write Best-Seller! Collect $80,000" 
									  andAmount:80000];
	[teach3 setNextSquare:bestSeller];
	
	BabySquare *twins2 = [[BabySquare alloc] initWithPosition:NSMakePoint(550, 700)
													   andSex:TWINS];
	[bestSeller setNextSquare:twins2];
	
	// right path
	FinanceSquare *charity = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(500, 680) 
									 andMessage:@"Host Charity Police Ball. Pay $15,000" 
									  andAmount:(-15000)];
	PoliceSquare *police1 = [[PoliceSquare alloc] initWithPosition:NSMakePoint(500, 680)
														 andSquare:charity];
	[twins2 setNextSquare:police1];
	
	PayDay *rightPayDay2 = [[PayDay alloc] initWithPosition:NSMakePoint(490, 630)];
	[police1 setNextSquare:rightPayDay2];
	
	FinanceSquare *treasure = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(490, 580) 
									 andMessage:@"Find Burried Treasure. Collect $80,000" 
									  andAmount:80000];
	[rightPayDay2 setNextSquare:treasure];
	
	TaxSquare *taxesDue3 = [[TaxSquare alloc] initWithPosition:NSMakePoint(490, 520)];
	AccountantSquare *account3 = [[AccountantSquare alloc] initWithPosition:NSMakePoint(490,520)
																  andSquare:taxesDue3];
	[treasure setNextSquare:account3];
	// end right path
	
	// left path
	FinanceSquare *invest = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(550, 650) 
									 andMessage:@"Invest in Broadway Play. Pay $15,000" 
									  andAmount:(-15000)];
	EntertainerSquare *entertain2 = [[EntertainerSquare alloc] initWithPosition:NSMakePoint(550, 650)
																	  andSquare:invest];
	[twins2 setNextSquare:entertain2];
	
	PayDay *leftPayDay2 = [[PayDay alloc] initWithPosition:NSMakePoint(550, 600)];
	[entertain2 setNextSquare:leftPayDay2];
	
	LifeSquare *health = [[LifeSquare alloc] initWithPosition:NSMakePoint(550, 550) 
												   andMessage:@"Join Health Club"];
	[leftPayDay2 setNextSquare:health];
	
	FinanceSquare *portrait = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(550, 490) 
									 andMessage:@"Family Portrait. Pay $35,000" 
									  andAmount:(-35000)];
	[health setNextSquare:portrait];
	
	SwapSalarySquare *swap3 = 
		[[SwapSalarySquare alloc] initWithPosition:NSMakePoint(550, 440)];
	[portrait setNextSquare:swap3];
	
	FinanceSquare *newCar = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(550, 385) 
									 andMessage:@"Buy Sports Car. Pay $25,000" 
									  andAmount:(-25000)];
	SalespersonSquare *sales4 = [[SalespersonSquare alloc] initWithPosition:NSMakePoint(550, 385)
																  andSquare:newCar];
	[swap3 setNextSquare:sales4];
	
	FinanceSquare *taxRefund = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(500, 380) 
									 andMessage:@"Tax Refund! Collect $25,000" 
									  andAmount:25000];
	[sales4 setNextSquare:taxRefund];
	// end left path
	
	PayDay *tenthPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(490, 455)];
	[account3 setNextSquare:tenthPayDay];
	[taxRefund setNextSquare:tenthPayDay];
	
	FinanceSquare *art = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(435, 460) 
									 andMessage:@"Give to Art Institute. Pay $25,000" 
									  andAmount:(-25000)];
	ArtistSquare *artist2 = [[ArtistSquare alloc] initWithPosition:NSMakePoint(435, 460)
														 andSquare:art];
	[tenthPayDay setNextSquare:artist2];
	
	LifeSquare *recycle = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(430, 510) 
								  andMessage:@"Recycle Your Trash!"];
	[artist2 setNextSquare:recycle];
	
	FinanceSquare *gameShow = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(430, 560) 
									 andMessage:@"TV Game Show Winner! Collect $95,000" 
									  andAmount:95000];
	[recycle setNextSquare:gameShow];
	
	ChildFinanceSquare *sSchool = 
		[[ChildFinanceSquare alloc] initWithPosition:NSMakePoint(430, 610) 
									 andMessage:@"Summer School. Pay $5,000 per child." 
									  andAmount:(-5000)];
	TeacherSquare *teach4 = [[TeacherSquare alloc] initWithPosition:NSMakePoint(430, 610)
														  andSquare:sSchool];
	[gameShow setNextSquare:teach4];
	
	LifeSquare *game = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(430, 660) 
								  andMessage:@"Play a Family Game"];
	[teach4 setNextSquare:game];
	
	LifeSquare *signLang = 
	[[LifeSquare alloc] initWithPosition:NSMakePoint(420, 715) 
							  andMessage:@"Learn Sign Language"];
	[game setNextSquare:signLang];
	
	FinanceSquare *cabin = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(350, 720) 
									 andMessage:@"Buy cabin on lake. Pay $90,000" 
									  andAmount:(-90000)];
	[signLang setNextSquare:cabin];
	
	PayDay *payDay11 = [[PayDay alloc] initWithPosition:NSMakePoint(300, 725)];
	[cabin setNextSquare:payDay11];
	
	HouseInsuranceSquare *burglar = 
		[[HouseInsuranceSquare alloc] initWithPosition:NSMakePoint(300, 775) 
											andMessage:@"Burglar! Pay $50,000 if not insured." 
											 andAmount:(-50000)];
	[payDay11 setNextSquare:burglar];
	
	FinanceSquare *nobel = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(350, 780) 
									 andMessage:@"Win Nobel Prize. Collect $100,000" 
									  andAmount:100000];
	[burglar setNextSquare:nobel];
	
	SwapSalarySquare *swap4 = 
		[[SwapSalarySquare alloc] initWithPosition:NSMakePoint(390, 790)];
	[nobel setNextSquare:swap4];
	
	FinanceSquare *gym = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(390, 840) 
									 andMessage:@"Spring for gym equipment. Pay $30,000" 
									  andAmount:(-30000)];
	AthleteSquare *athlete3 = [[AthleteSquare alloc] initWithPosition:NSMakePoint(390, 840)
															andSquare:gym];
	[swap4 setNextSquare:athlete3];
	
	StockSquare *crash2 = [[StockSquare alloc] initWithPosition:NSMakePoint(340, 850) 
											  andNumberOfStocks:(-1)];
	[athlete3 setNextSquare:crash2];
	
	FinanceSquare *tornado = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(280, 840) 
									 andMessage:@"Tornado Hits House! Pay $125,000 if not insured!" 
									  andAmount:(-125000)];
	[crash2 setNextSquare:tornado];
	
	PayDay *payDay12 = [[PayDay alloc] initWithPosition:NSMakePoint(240, 790)];
	[tornado setNextSquare:payDay12];
	
	FinanceSquare *mooshu = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(190, 750) 
									 andMessage:@"Moo-Shu Flu Attack. Pay $25,000" 
									  andAmount:(-25000)];
	DoctorSquare *doc3 = [[DoctorSquare alloc] initWithPosition:NSMakePoint(1980, 750)
													  andSquare:mooshu];
	[payDay12 setNextSquare:doc3];
	
	TaxSquare *taxesDue4 = [[TaxSquare alloc] initWithPosition:NSMakePoint(150, 650)];
	AccountantSquare *account4 = [[AccountantSquare alloc] initWithPosition:NSMakePoint(150,650)
																  andSquare:taxesDue4];
	[doc3 setNextSquare:account4];
	
	FinanceSquare *boat = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(80, 630) 
									 andMessage:@"Buy Sailboat. Pay $30,000" 
									  andAmount:(-30000)];
	SalespersonSquare *sales5 = [[SalespersonSquare alloc] initWithPosition:NSMakePoint(80, 630)
																  andSquare:boat];
	[account4 setNextSquare:sales5];
	
	FinanceSquare *golf = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(70, 560) 
									 andMessage:@"Sponsor Golf Tournament. Pay $35,000" 
									  andAmount:(-35000)];
	AthleteSquare *athlete4 = [[AthleteSquare alloc] initWithPosition:NSMakePoint(70, 560)
															andSquare:golf];
	[sales5 setNextSquare:athlete4];
	
	CareerSquare *midlife = 
		[[CareerSquare alloc] initWithPosition:NSMakePoint(70, 510) 
									andMessage:@"Midlife Crisis. Start New Career"];
	[athlete4 setNextSquare:midlife];
	
	SpinAgainSquare *spin1 = 
		[[SpinAgainSquare alloc] initWithPosition:NSMakePoint(70, 460)];
	[midlife setNextSquare:spin1];
	
	PayDay *payDay13 = [[PayDay alloc] initWithPosition:NSMakePoint(70, 400)];
	[spin1 setNextSquare:payDay13];
	
	FinanceSquare *rock = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(150, 320) 
									 andMessage:@"Produce Rock Video. Pay $100,000" 
									  andAmount:(-100000)];
	[payDay13 setNextSquare:rock];
	
	SwapSalarySquare *swap5 = 
		[[SwapSalarySquare alloc] initWithPosition:NSMakePoint(220, 315)];
	[rock setNextSquare:swap5];
	
	LifeSquare *help = [[LifeSquare alloc] initWithPosition:NSMakePoint(285, 315) 
												 andMessage:@"Help the Homeless"];
	[swap5 setNextSquare:help];
	
	SpinAgainSquare *spin2 = 
		[[SpinAgainSquare alloc] initWithPosition:NSMakePoint(360, 315)];
	[help setNextSquare:spin2];
	
	FinanceSquare *tats = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(430, 290)
									 andMessage:@"Have Tattoos Removed. Pay $100,000" 
									  andAmount:(-100000)];
	DoctorSquare *doc4 = [[DoctorSquare alloc] initWithPosition:NSMakePoint(430, 290)
													  andSquare:tats];
	[spin2 setNextSquare:doc4];
	
	ChildFinanceSquare *college = 
		[[ChildFinanceSquare alloc] initWithPosition:NSMakePoint(450, 230)
										  andMessage:@"College. Pay $50,000 Per Child" 
										   andAmount:(-50000)];
	TeacherSquare *teach5 = [[TeacherSquare alloc] initWithPosition:NSMakePoint(450,230)
															   andSquare:college];
	[doc4 setNextSquare:teach5];

	PayDay *payDay14 = [[PayDay alloc] initWithPosition:NSMakePoint(470, 170)];
	[teach5 setNextSquare:payDay14];
	
	TaxSquare *taxesDue5 = [[TaxSquare alloc] initWithPosition:NSMakePoint(520, 180)];
	AccountantSquare *account5 = [[AccountantSquare alloc] initWithPosition:NSMakePoint(520, 180)
																  andSquare:taxesDue5];
	[payDay14 setNextSquare:account5];
	
	SpinAgainSquare *spin3 = 
		[[SpinAgainSquare alloc] initWithPosition:NSMakePoint(515, 235)]; 
	[account5 setNextSquare:spin3];
	
	LifeSquare *war = [[LifeSquare alloc] initWithPosition:NSMakePoint(520, 310) 
												andMessage:@"Visit War Memorial"];
	[spin3 setNextSquare:war];
	
	FinanceSquare *artExhibit = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(640, 310) 
									 andMessage:@"Sponsor Art Exhibit. Pay $125,000" 
									  andAmount:(-125000)];
	ArtistSquare *artist3 = [[ArtistSquare alloc] initWithPosition:NSMakePoint(640, 310)
														 andSquare:artExhibit];
	[war setNextSquare:artist3];
	
	// TODO:  Find missing squares
	LifeSquare *fishing = [[LifeSquare alloc] initWithPosition:NSMakePoint(690, 100) 
													andMessage:@"Go Fishing"];
	[artist3 setNextSquare:fishing];
	
	SpinAgainSquare *spin4 = 
		[[SpinAgainSquare alloc] initWithPosition:NSMakePoint(730, 60)];
	[fishing setNextSquare:spin4];
	
	FinanceSquare *jockey = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(780, 50) 
									 andMessage:@"Hire jockey for your Racehorese. Pay $65,000" 
									  andAmount:(-65000)];
	AthleteSquare *athlete5 = [[AthleteSquare alloc] initWithPosition:NSMakePoint(780, 50)
															andSquare:jockey];
	[spin4 setNextSquare:athlete5];
	
	LifeSquare *hike = [[LifeSquare alloc] initWithPosition:NSMakePoint(835, 50) 
												 andMessage:@"Take a Hike!"];
	[athlete5 setNextSquare:hike];
	
	PayDay *payday15 = [[PayDay alloc] initWithPosition:NSMakePoint(890, 50)];
	[hike setNextSquare:payday15];
	
	LifeSquare *arbor = [[LifeSquare alloc] initWithPosition:NSMakePoint(950, 50)
												andMessage:@"Arbor Day! Plant a Tree"];
	[payday15 setNextSquare:arbor];
	
	SpinAgainSquare *spin5 = 
		[[SpinAgainSquare alloc] initWithPosition:NSMakePoint(1000, 50)];
	[arbor setNextSquare:spin5];
	
	LifeSquare *wildlife = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1060, 50) 
								  andMessage:@"Support Wildlife Fund"];
	[spin5 setNextSquare:wildlife];
	
	FinanceSquare *europe = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1110, 80) 
									 andMessage:@"Tour Europe. Pay $45,000" 
									  andAmount:(-45000)];
	TravelAgentSquare *travel4 = [[TravelAgentSquare alloc] initWithPosition:NSMakePoint(1110, 80)
																   andSquare:europe];
	[wildlife setNextSquare:travel4];
	
	LifeSquare *grandparent = 
		[[LifeSquare alloc] initWithPosition:NSMakePoint(1120, 130) 
								  andMessage:@"You're a grandparent!"];
	[travel4 setNextSquare:grandparent];
	
	PayDay *lastPayDay = [[PayDay alloc] initWithPosition:NSMakePoint(1100, 190)];
	[grandparent setNextSquare:lastPayDay];
	
	FinanceSquare *grammy = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1035, 180) 
									 andMessage:@"Throw Party for Grammy Winners. Pay $35,000" 
									  andAmount:(-35000)];
	EntertainerSquare *entertain3 = [[EntertainerSquare alloc] initWithPosition:NSMakePoint(1035, 180)
																	  andSquare:grammy];
	[lastPayDay setNextSquare:entertain3];
	
	FinanceSquare *cruise = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(1020, 120) 
									 andMessage:@"Go on Luxury Cruise. Pay $55,000" 
									  andAmount:(-55000)];
	TravelAgentSquare *travel5 = [[TravelAgentSquare alloc] initWithPosition:NSMakePoint(1020, 1020)
																   andSquare:cruise];
	[entertain3 setNextSquare:travel5];
	
	FinanceSquare *pension = 
		[[FinanceSquare alloc] initWithPosition:NSMakePoint(970, 120) 
									 andMessage:@"Pension. Collect $20,000 x Number Spun" 
									  andAmount:(spunNumber*20000)];
	[travel5 setNextSquare:pension];
	
	// retirement!
	RetirementSquare *ret = 
		[[RetirementSquare alloc] initWithPosition:NSMakePoint(950, 200)];
	[pension setNextSquare:ret];

	CountrysideAcresSquare *countryside = [[RetirementSquare alloc] initWithPosition:NSMakePoint(840, 200)];

	MillionaireEstatesSquare *millionaire = [[RetirementSquare alloc] initWithPosition:NSMakePoint(860, 250)];

	[ret setNextSquare:countryside];
	[ret setNextSquare:millionaire];
}

@end

@implementation Board

@synthesize startCollegeSquare, startCareerSquare;

- (id)init {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
		[self initSquares];
	}
	return self;
}

@end
