//
//  BuyHouseSquare.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 4/25/09.
//

#import "BuyHouseSquare.h"
#import "Player.h"
#import "Game.h"
#import "Card.h"

@implementation BuyHouseSquare

- (id)initWithPosition:(NSPoint)aPoint {
	if( self = [super initWithPosition:aPoint andMessage:@"Buy A House!"] ) {
		theGame = [Game getInstance];
	}
	return self;
}

- (void)performSquareAction:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Card *houseCard = [theGame houseCard];

	NSMutableDictionary *userInfo = [[NSMutableDictionary alloc] init];
	[userInfo setObject:houseCard forKey:@"HouseCard"];
	[userInfo setObject:[aPlayer name] forKey:@"PlayerName"];

	[[NSNotificationCenter defaultCenter] postNotificationName:@"ShowHouseSheet"
														object:self
													  userInfo:userInfo];
	[aPlayer giveCard:houseCard];
}

@end
