//
//  CareerSquare.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/23/09.
//

#import "CareerSquare.h"
#import "Player.h"
#import "CareerCard.h"
#import "SalaryCard.h"
#import "Career.h"
#import "Game.h"

@implementation CareerSquare

- (id)initWithPosition:(NSPoint)aPoint andMessage:(NSString*)aMessage {
	if( self = [super initWithPosition:aPoint andMessage:aMessage] ) {
		
	}
	return self;
}

- (void)performSquareAction:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Game *theGame = [Game getInstance];
	Card *card = [theGame careerCard];
	BOOL hasDegree = [aPlayer goToCollege];
	while( !hasDegree && [card degreeRequired] ) {
		[theGame replaceCareerCard:card];
		card = [theGame careerCard];
	}
	Card *sCard = [theGame salaryCard];

	NSMutableDictionary *userInfo = [[NSMutableDictionary alloc] init];
	[userInfo setObject:[card name] forKey:@"CareerName"];
	[userInfo setObject:[NSString stringWithFormat:@"%d", [sCard salary]] forKey:@"SalaryAmount"];
	[userInfo setObject:[NSString stringWithFormat:@"%d", [sCard taxes]] forKey:@"TaxAmount"];
	[userInfo setObject:[aPlayer name] forKey:@"PlayerName"];

	[[NSNotificationCenter defaultCenter] postNotificationName:@"ShowCareerSheet"
														object:self
													  userInfo:userInfo];

	[aPlayer giveCard:card];
	[aPlayer giveCard:sCard];
}

@end
