//
//  Deck.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/23/09.
//

#import "Deck.h"
#import "Card.h"
#import "CareerCard.h"
#import "StockCard.h"
#import "SalaryCard.h"
#import "HouseCard.h"
#import "LifeTile.h"

@implementation Deck

+ (Deck*)getCareerDeck {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Deck *careerDeck = [[Deck alloc] initDeckWithReplacement:NO];
	
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Teacher" isDegreeRequired:YES]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Salesperson" isDegreeRequired:NO]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Doctor" isDegreeRequired:YES]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Police Officer" isDegreeRequired:NO]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Travel Agent" isDegreeRequired:NO]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Entertainer" isDegreeRequired:NO]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Athlete" isDegreeRequired:NO]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Accountant" isDegreeRequired:YES]];
	[careerDeck addCard:[[CareerCard alloc] initWithCareer:@"Artist" isDegreeRequired:NO]];
	
	return careerDeck;
}

+ (Deck*)getStockDeck {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Deck *stockDeck = [[Deck alloc] initDeckWithReplacement:NO];
	
	[stockDeck addCard:[[StockCard alloc] initWithNumber:1 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:2 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:3 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:4 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:5 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:6 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:7 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:8 andCost:50000]];
	[stockDeck addCard:[[StockCard alloc] initWithNumber:9 andCost:50000]];
	
	return stockDeck;
}

+ (Deck*)getSalaryDeck {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Deck *salaryDeck = [[Deck alloc] initDeckWithReplacement:NO];
	
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:20000  andTaxes:5000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:30000  andTaxes:10000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:40000  andTaxes:15000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:50000  andTaxes:20000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:60000  andTaxes:25000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:70000  andTaxes:30000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:80000  andTaxes:35000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:90000  andTaxes:40000]];
	[salaryDeck addCard:[[SalaryCard alloc] initWithSalary:100000 andTaxes:45000]];

	return salaryDeck;
}

+ (Deck*)getHouseDeck {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Deck *houseDeck = [[Deck alloc] initDeckWithReplacement:NO];
	
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Dutch Colonial" 
										andDescription:@"8 spacious rooms w/ study, den, Solar-heated, wood-burning stoves, solid oak floors" 
											andRealtor:@"Wooden Shoe Realty" 
											   andCost:120000 
									  andInsuranceCost:30000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Tudor" 
										andDescription:@"Tufloors, tubaths, tucar garage. Perfect for tupeople with tukids or more!" 
											andRealtor:@"Tutime Realty" 
											   andCost:180000 
									  andInsuranceCost:45000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Victorian" 
										andDescription:@"Library, parlor, servants' quarters, marble fireplaces, wraparound porch." 
											andRealtor:@"Blithering Heights Realty" 
											   andCost:200000 
									  andInsuranceCost:50000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Log Cabin" 
										andDescription:@"Rustic charm in a woodland setting. Loft w/skylight, stone fireplace. Near Lake Ketcheefishee." 
											andRealtor:@"Tutime Realty" 
											   andCost:80000 
									  andInsuranceCost:20000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Cozy Condo" 
										andDescription:@"This beautiful 2-level condominium comes complete with gourmet kitchen and rooftop garden." 
											andRealtor:@"Sandwich Inn Realty" 
											   andCost:100000 
									  andInsuranceCost:25000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Mobile Home" 
										andDescription:@"Aluminum-sided little beauty! Great location, lovely view. Trailer hitch included." 
											andRealtor:@"Deals on Wheels Realty" 
											   andCost:60000 
									  andInsuranceCost:15000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Farmhouse" 
										andDescription:@"Located on 50 rolling acres! Garbanzo bean crops, prizewinning pigs & dairy cows, spacious barn w/ silo." 
											andRealtor:@"Euell B. Milken Realty" 
											   andCost:160000 
									  andInsuranceCost:40000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Beach House" 
										andDescription:@"Only 50 yards from Monsoon Beach. Sun deck, boat dock, hurricane wall. Hurry while it lasts!" 
											andRealtor:@"High Winds Realty" 
											   andCost:140000 
									  andInsuranceCost:35000]];
	[houseDeck addCard:[[HouseCard alloc] initWithName:@"Split-Level" 
										andDescription:@"Was one level before the 'quake.  Now a real fixer-upper for adventurous folks!" 
											andRealtor:@"Faultline Realty" 
											   andCost:40000 
									  andInsuranceCost:10000]];
	
	return houseDeck;
}

+ (Deck*)getTilePile {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	Deck *tilePile = [[Deck alloc] initDeckWithReplacement:NO];
	
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Become President" 
											  andAmount:250000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Invent New Sport" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Pulitzer Prize" 
											  andAmount:100000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Paint a Masterpiece" 
											  andAmount:150000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Write Great American Novel" 
											  andAmount:150000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Swim English Channel" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Design New Computer" 
											  andAmount:100000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Invent New Ice Cream Flavor" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Build Better Mousetrap" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Solution to Pollution" 
											  andAmount:250000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Find New Energy Source" 
											  andAmount:200000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Win Dance Contest" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Discover New Planet" 
											  andAmount:100000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Lifetime Achievement Award"
											  andAmount:100000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Family Horse Wins Derby"
											  andAmount:150000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Save Endangered Species" 
											  andAmount:200000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Toy Invention Sells Big"
											  andAmount:150000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Climb Mt. Everest"
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Cure the Common Cold"
											  andAmount:200000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Open Health Food Chain"
											  andAmount:100000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Run World Record Mile" 
											  andAmount:50000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Create New Teaching Method"
											  andAmount:200000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Compose a Symphony"
											  andAmount:150000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Noel Peace Prize"
											  andAmount:250000]];
	[tilePile addCard:[[LifeTile alloc] initWithMessage:@"Humanitarian Award" 
											  andAmount:100000]];
	
	return tilePile;
}

- (id)init {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
		replace = NO;
		cards = [[NSMutableArray alloc] init];
	}
	
	return self;
}

- (id)initDeckWithReplacement:(BOOL)shouldReplace {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
		replace = shouldReplace;
		cards = [[NSMutableArray alloc] init];
	}
	
	return self;
}

- (void)addCard:(Card*)aCard {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[cards addObject:aCard];
}

- (Card*)getCard {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	srand( time(NULL) );
	NSInteger index = rand() % [cards count];
	Card *aCard = [cards objectAtIndex:index];
	
	if( !replace )
		[cards removeObjectAtIndex:index];
	
	return aCard;
}

- (NSInteger)getRemaining {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	return [cards count];
}

- (void)replaceCard:(Card*)aCard {
	[cards addObject:aCard];
}

@end
