//
//  Game.h
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 4/18/09.
//

#import <Cocoa/Cocoa.h>

@class Board;
@class Deck;
@class Player;
@class Card;
@class SalaryCard;
@class HouseCard;
@class CareerCard;
@class LifeTile;
@class StockCard;
@class Turn;

@interface Game : NSObject {
	Board *theBoard;
	NSMutableArray *players;
	Deck *careerDeck;
	Deck *stockDeck;
	Deck *salaryDeck;
	Deck *tilePile;
	Deck *houseDeck;
	Turn *currentTurn;
}

@property (readonly) NSMutableArray* players;

+ (Game*)getInstance;
- (void)addPlayer:(Player*)aPlayer;
- (void)removePlayer:(Player*)aPlayer;
- (NSInteger)numberOfPlayers;
- (void)start;
- (void)startNextTurn:(NSNotification*)aNotification;
- (Card*)lifeTile;
- (Card*)salaryCard;
- (void)replaceSalaryCard:(Card*)aCard;
- (Card*)stockCard;
- (void)replaceStockCard:(Card*)aCard;
- (Card*)careerCard;
- (void)replaceCareerCard:(Card*)aCard;
- (Card*)houseCard;
- (void)replaceHouseCard:(Card*)aCard;
- (Board*)board;

@end


