//
//  GameController.h
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 4/11/09.
//

#import <Cocoa/Cocoa.h>

@class Player;
@class PlayerTableDataSource;
@class Game;
@class BoardView;

@interface GameViewController : NSObject {
	IBOutlet NSWindow *mainWindow;

	// Career Sheet Variables
	IBOutlet NSWindow *careerSheet;
	IBOutlet NSTextField *careerName;
	IBOutlet NSTextField *salaryAmount;
	IBOutlet NSTextField *taxAmount;
	IBOutlet NSTextField *playerName;

	// House Sheet Variables
	IBOutlet NSWindow *houseSheet;
	IBOutlet NSTextField *housePlayerName;
	IBOutlet NSTextField *houseDescription;
	IBOutlet NSTextField *housePrice;
	IBOutlet NSTextField *houseInsurance;

	// New Game Sheet and Variables
	IBOutlet NSWindow *newGameSheet;
	IBOutlet NSPopUpButton *numPlayers;

	// New Player Sheet Variables
	IBOutlet NSWindow *addPlayerSheet;
	IBOutlet NSTextField *curPlayerName;
	IBOutlet NSButton *goToCollege;
	IBOutlet NSMatrix *carButtons;

	// Bank Sheet
	IBOutlet NSWindow *bankSheet;

	// Insurance Sheet
	IBOutlet NSWindow *insuranceSheet;

	// Swap Salary Sheet
	IBOutlet NSWindow *swapSheet;
	IBOutlet NSButton *swapButton;
	IBOutlet NSButton *closeButton;

	NSUInteger playerCount;
	NSUInteger addedPlayers;
	
	IBOutlet PlayerTableDataSource *playerTable;
	BOOL isStarted;
	
	Game *theGame;
}

- (IBAction)showNewGameSheet:(id)sender;
- (IBAction)newGameSheetOKButtonPressed:(id)sender;
- (IBAction)newGameSheetCancelButtonPressed:(id)sender;
- (void)closeNewGameSheet:(id)sender;

- (IBAction)showAddPlayerSheet:(id)sender;
- (IBAction)addPlayerSheetOKButtonPressed:(id)sender;
- (IBAction)addPlayerSheetCancelButtonPressed:(id)sender;
- (void)closeAddPlayerSheet:(id)sender;

- (void)beginGame;

- (void)addPlayer:(Player*)aPlayer;
- (void)resetGame;

- (void)showCareerSheet:(NSNotification*)aNotification;
- (IBAction)closeCareerSheet:(id)sender;

- (void)showHouseSheet:(NSNotification*)aNotification;
- (IBAction)closeHouseSheet:(id)sender;
- (IBAction)buyHouseInsurance:(id)sender;

- (IBAction)showInsuranceSheet:(id)sender;
- (IBAction)closeInsuranceSheet:(id)sender;
- (IBAction)buyCarInsurance:(id)sender;

- (IBAction)buyStock:(id)sender;

- (IBAction)showBankSheet:(id)sender;
- (IBAction)closeBankSheet:(id)sender;

- (IBAction)showSwapSalrySheet:(NSNotification*)aNotification;
- (IBAction)closeSwapSalarySheet:(id)sender;

@end
