//
//  HouseCard.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/23/09.
//

#import "HouseCard.h"
#import "Player.h"
#import "House.h"

@implementation HouseCard

@synthesize name, description, realtor;
@synthesize cost, insuranceCost;

- (id)initWithName:(NSString*)aName
	andDescription:(NSString*)aDescription
		andRealtor:(NSString*)aRealtor
		   andCost:(NSInteger)aCost
  andInsuranceCost:(NSInteger)anInsCost {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
		name = aName;
		description = aDescription;
		realtor = aRealtor;
		cost = aCost;
		insuranceCost = anInsCost;
	}
	return self;
}

- (void)doCardActionToPlayer:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	House *newHouse = [[House alloc] init];
	[newHouse setPrice:cost];
	[newHouse setInsurancePrice:insuranceCost];
	[newHouse setDescription:description];
	NSInteger money = [aPlayer money];
	money -= cost;
	[aPlayer setMoney:money];
	[aPlayer setHouse:newHouse];
}

@end
