//
//  NightSchoolSquare.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/31/09.
//

#import "NightSchoolSquare.h"
#import "Player.h"
#import "Card.h"
#import "CareerCard.h"
#import "SalaryCard.h"
#import "Game.h"

@implementation NightSchoolSquare

@synthesize amount;

- (id)initWithPosition:(NSPoint)aPoint andMessage:(NSString*)aMessage andAmount:(NSInteger)anAmount {
	if( self = [super initWithPosition:aPoint andMessage:aMessage] ) {
		amount = anAmount;
	}
	return self;
}

- (void)performSquareAction:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	NSInteger money = [aPlayer money];
	money += amount;
	[aPlayer setMoney:money];

	NSAlert *choice = [NSAlert alertWithMessageText:@"Do you wish to change careers?"
								  defaultButton:@"Yes"
								alternateButton:@"No"
									otherButton:nil
					  informativeTextWithFormat:@""];

	NSInteger userChoice = [choice runModal];

	if( userChoice == NSAlertDefaultReturn ) {
		Game *theGame = [Game getInstance];
		Card *card = [theGame careerCard];
		BOOL hasDegree = [aPlayer goToCollege];
		while( !hasDegree && [card degreeRequired] ) {
			[theGame replaceCareerCard:card];
			card = [theGame careerCard];
		}
		Card *sCard = [theGame salaryCard];

		NSMutableDictionary *userInfo = [[NSMutableDictionary alloc] init];
		[userInfo setObject:[card name] forKey:@"CareerName"];
		[userInfo setObject:[NSString stringWithFormat:@"%d", [sCard salary]] forKey:@"SalaryAmount"];
		[userInfo setObject:[NSString stringWithFormat:@"%d", [sCard taxes]] forKey:@"TaxAmount"];
		[userInfo setObject:[aPlayer name] forKey:@"PlayerName"];

		[[NSNotificationCenter defaultCenter] postNotificationName:@"ShowCareerSheet"
															object:self
														  userInfo:userInfo];

		[aPlayer giveCard:card];
		[aPlayer giveCard:sCard];
	}
}

@end
