//
//  Player.h
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/9/09.
//

#import <Cocoa/Cocoa.h>

@class Career;
@class Insurance;
@class Card;
@class Car;
@class Loan;
@class Square;
@class Child;
@class House;

@interface Player : NSObject {
	NSString *name;
	NSInteger money;
	NSMutableArray *loans;
	Career *career;
	BOOL goToCollege;
	NSMutableArray *insurance;
	NSMutableArray *children;
	Car *car;
	NSString *sex;
	BOOL married;
	Square *position;
	BOOL retired;
	BOOL isFirstTurn;
	NSMutableArray *collectedLifeTiles;
	House *house;
	NSInteger stockNumber;
}

@property (readwrite, retain) Career *career;
@property (readonly) NSString *name;
@property (readwrite, assign) NSInteger money;
@property (readwrite) BOOL goToCollege;
@property (readwrite, retain) Car *car;
@property (readwrite, retain) NSString *sex;
@property (readwrite) BOOL married;
@property (readonly) NSMutableArray *loans;
@property (readwrite) Square *position;
@property (readwrite) BOOL isFirstTurn;
@property (readwrite, retain) House *house;
@property (readwrite, assign) NSInteger stockNumber;
@property (readonly, retain) NSArray *collectedLifeTiles;

- (NSInteger)getNetWorth;
- (id)initWithName:(NSString*) aName andMoney:(NSInteger)money;
- (void)addInsurance:(Insurance*)anInsurancePolicy;
- (BOOL)hasCarInsurance;
- (BOOL)hasHouseInsurance;
- (void)giveCard:(Card*)aCard;
- (void)addLoan:(Loan*)aLoan;
- (void)payLoan:(Loan*)aLoan;
- (BOOL)hasLoans;
- (Square*)position;
- (void)setPosition:(Square*)aSquare;
- (void)setStartPosition:(Square*)aSquare;
- (void)addChild:(Child*)aChild;
- (NSInteger)children;
- (void)setRetired:(BOOL)ret;
- (BOOL)isRetired;
- (void)giveLifeTile:(Card*)aCard;

@end

