//
//  SpinController.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 2/21/09.
//

#import "SpinController.h"
#import "SpinThread.h"

@implementation SpinController

- (id) init {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
		
	}
	return self;
}

- (void) awakeFromNib {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[spinner pauseRendering];
}

- (void) setCurrentNumber:(NSInteger)number {
	//debug(@"%s:%d", __FUNCTION__, __LINE__);
	curNumber = number;
	[spunNumber setIntValue:curNumber];
}

- (NSInteger) getCurrentNumber {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( ![thread isFinished] )
		return curNumber;
	else
		return -1;
}

- (IBAction) doSpin:(id)sender {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	thread = [[SpinThread alloc] init];
	[thread setParent:self];
	[spinner stopRendering];
	[spinner startRendering];
	[thread start];
}

- (void) spinThreadDidFinish {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[thread cancel];
	NSNumber *num = [NSNumber numberWithInt:curNumber];
	NSDictionary *userInfo = [NSDictionary dictionaryWithObject:num 
														 forKey:@"number"];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"SpinFinished" 
														object:self
													  userInfo:userInfo];
}

@end
