//
//  Square.h
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/23/09.
//

#import <Cocoa/Cocoa.h>

@class SquareChoiceController;
@class Player;

@interface Square : NSObject {
	NSPoint position;
	BOOL occupied;
	NSColor *color;
	NSString *message;
	NSMutableArray *nextSquares;
	SquareChoiceController *squareController;
}

@property (readonly, assign) NSPoint position;
@property (readwrite, assign) BOOL occupied;
@property (readwrite, retain) NSColor *color;
@property (readwrite, retain) NSString *message;

- (id)initWithPosition:(NSPoint)aPoint andMessage:(NSString*)aMessage;
- (void)setNextSquare:(Square*)aSquare;
- (Square*)nextSquare;
- (Square*)showSquareChoice;
- (void)performSquareAction:(Player*)aPlayer;
- (BOOL)shouldStop;

@end

