//
//  Square.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 3/23/09.
//

#import "Square.h"
#import "SquareChoiceController.h"
#import "Player.h"

@implementation Square

@synthesize position;
@synthesize occupied;
@synthesize color;
@synthesize message;

- (id)initWithPosition:(NSPoint)aPoint andMessage:(NSString*)aMessage {
	if( self = [super init] ) {
		position = aPoint;
		message = aMessage;
		nextSquares = [[NSMutableArray alloc] init];
		squareController = [SquareChoiceController getInstance];
	}
	return self;
}


- (void)setNextSquare:(Square*)aSquare {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[nextSquares addObject:aSquare];
}

- (Square*)nextSquare {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	
	if( [nextSquares count] == 0 )
	{
		return nil;
	} else {
		if( [nextSquares count] == 1 ) {
			return [nextSquares objectAtIndex:0];
		} else {
			return [self showSquareChoice];
		}
	}
}

- (Square*)showSquareChoice {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	squareController = [SquareChoiceController getInstance];
	[squareController setLeftSquareText:[[nextSquares objectAtIndex:0] message]];
	[squareController setRightSquareText:[[nextSquares objectAtIndex:1] message]];
	NSInteger choice = [squareController showSquareChoiceSheet];
	return [nextSquares objectAtIndex:choice];
}

- (void)performSquareAction:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
}

- (BOOL)shouldStop {
	return NO;
}

@end
