//
//  SquareChoiceController.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 4/22/09.
//

#import "SquareChoiceController.h"
#import "Square.h"

static SquareChoiceController *controller = nil;

@implementation SquareChoiceController

- (id)init {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	if( self = [super init] ) {
	
	}
	controller = self;
	return self;
}

+ (SquareChoiceController*)getInstance {
	return controller;
}

// guaranteed to be called when the window loads and before getInstance is
// ever called.  Thus we can treat this class as a singleton without enforcement
- (void)awakeFromNib {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	controller = self;
}

- (IBAction)okButtonPressed:(id)sender {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[NSApp stopModal];
}

- (void)setLeftSquareText:(NSString*)squareText {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[leftChoice setStringValue:squareText];
}

- (void)setRightSquareText:(NSString*)squareText {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[rightChoice setStringValue:squareText];
}

- (NSInteger)showSquareChoiceSheet {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[NSApp beginSheet:choiceWindow 
	   modalForWindow:mainWindow 
		modalDelegate:nil
	   didEndSelector:NULL
		  contextInfo:NULL];
	[NSApp runModalForWindow:choiceWindow];
	// modal until user selects an option
	
	[NSApp endSheet:choiceWindow];
	[choiceWindow orderOut:self];
	
	// check for selected square and return it
	NSButtonCell *selectedCell = [radioMatrix selectedCell];

	return [selectedCell tag];
}

@end
