//
//  SwapSalaryViewController.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 5/10/09.
//

#import "SwapSalaryViewController.h"
#import "Game.h"
#import "Player.h"
#import "Career.h"
#import "PlayerTableDataSource.h"

static SwapSalaryViewController* theController = nil;

@implementation SwapSalaryViewController

+ (SwapSalaryViewController*)getInstance {
	return theController;
}

- (void)awakeFromNib {
	theController = self;
}

- (NSInteger)numberOfRowsInTableView:(NSTableView*)aTable {
	Game *theGame = [Game getInstance];
	NSArray *players = [theGame players];
	if( [players count] > 0 ) {
		return [players count];
	} else {
		return 0;
	}
}

- (id)tableView:(NSTableView*)aTable objectValueForTableColumn:(NSTableColumn*)aColumn row:(NSInteger)row {
	Game *theGame = [Game getInstance];
	NSArray *players = [theGame players];
	Player *player = [players objectAtIndex:row];
	NSString *identifier = [aColumn identifier];
	
	if( [identifier caseInsensitiveCompare:@"1"] == NSOrderedSame ) {
		return [player name];
	} else if ( [identifier caseInsensitiveCompare:@"2"] == NSOrderedSame ) {
		Career *c = [player career];
		NSInteger salary = [c salary];
		NSString *salaryString = [NSString stringWithFormat:@"%d", salary];
		return salaryString;
	} else if ( [identifier caseInsensitiveCompare:@"3"] == NSOrderedSame ) {
		Career *c = [player career];
		NSInteger taxes = [c taxes];
		NSString *taxString = [NSString stringWithFormat:@"%d", taxes];
		return taxString;
	} else {
		return nil;
	}
}

- (IBAction)doSwapButton:(id)sender {
	[swapButton setEnabled:NO];
	[closeButton setEnabled:YES];
	Game *theGame = [Game getInstance];

	Player *curPlayer = [playerTable currentPlayer];
	NSArray *players = [theGame players];
	Player *swapPlayer = [players objectAtIndex:[tableView selectedRow]];

	Career *curPlayerCareer = [curPlayer career];
	Career *swapPlayerCareer = [swapPlayer career];

	NSInteger tmpSalary = [curPlayerCareer salary];
	NSInteger tmpTaxes = [curPlayerCareer taxes];

	NSInteger newSalary = [swapPlayerCareer salary];
	NSInteger newTaxes = [swapPlayerCareer taxes];

	[curPlayerCareer setSalary:newSalary];
	[curPlayerCareer setTaxes:newTaxes];
	[curPlayer setCareer:curPlayerCareer];

	[swapPlayerCareer setSalary:tmpSalary];
	[swapPlayerCareer setTaxes:tmpTaxes];
	[swapPlayer setCareer:swapPlayerCareer];
}

@end
