//
//  TeacherSquare.m
//  GameOfLife
//
//  Created by Grant Limberg, Kevin Toste on 5/4/09.
//

#import "TeacherSquare.h"
#import "Game.h"
#import "Player.h"
#import "Career.h"

@implementation TeacherSquare

- (id)initWithPosition:(NSPoint)aPoint andSquare:(Square*)aSquare  {
	if( self = [super initWithPosition:aPoint andMessage:@""] ) {
		wrappedSquare = aSquare;
	}
	return self;
}

- (void)performSquareAction:(Player*)aPlayer {
	debug(@"%s:%d", __FUNCTION__, __LINE__);
	[wrappedSquare performSquareAction:(Player*)aPlayer];

	NSArray *players = [[Game getInstance] players];
	for(Player *p in players ) {
		if( [[[p career] careerName] caseInsensitiveCompare:@"Teacher"] == NSOrderedSame && 
				aPlayer != p ) {
			NSInteger money = [p money];
			NSInteger amount = [wrappedSquare amount];
			money -= amount;
			[p setMoney:money];
		}
	}
}

- (NSString*)message {
	return [wrappedSquare message];
}

@end
