//
//  PlayerTest.m
//  GameOfLife
//
//  Created by Grant Limberg on 4/18/09.
//  Copyright 2009 GL Software. All rights reserved.
//

#import "PlayerTest.h"

#import "Player.h"
#import "CarInsurance.h"
#import "LifeInsurance.h"

#import <OCMock/OCMock.h>
#import "OCMockRecorder_Boolean.h"

@implementation PlayerTest

- (void)setUp {
	aPlayer = [[Player alloc] initWithName:@"TestPlayer" andMoney:10000];
}

- (void)tearDown {
	aPlayer = NULL;
}

- (void)testGoToCollege {
	[aPlayer setGoToCollege:YES];
	STAssertTrue( [aPlayer goToCollege], @"goToCollege should be True" );
}

- (void)testNetWorth {
	NSInteger debt = 5000;
	[aPlayer setDebt:debt];
	STAssertEquals( debt, [aPlayer getNetWorth], @"Debt and Net worth should be equal!");
}

- (void)testHasCarInsurance {
	mockInsurance = [OCMockObject mockForClass:[CarInsurance class]];
	[[[mockInsurance stub] andReturnBoolean:YES] isMemberOfClass:OCMOCK_ANY];
	[aPlayer addInsurance:mockInsurance];
	STAssertTrue( [aPlayer hasCarInsurance], @"Should have car insurance!");
}

- (void)testHasLifeInsurance {
	mockInsurance = [OCMockObject mockForClass:[LifeInsurance class]];
	[[[mockInsurance stub] andReturnBoolean:YES] isMemberOfClass:OCMOCK_ANY];
	[aPlayer addInsurance:mockInsurance];
	STAssertTrue( [aPlayer hasLifeInsurance], @"Should have life insurance!");
}

@end
